#include "FastLED.h"

// How many leds are in the strip?
#define NUM_LEDS 173

// Data pin that led data will be written out over
#define DATA_PIN 4

// This is an array of leds.  One item for each led in your strip.
CRGB leds[NUM_LEDS];

void setup(){
  Serial.begin(115200);
  //sanity check delay - allows reprogramming if accidently blowing power w/leds
  delay(3000);
   
  // Change this to match your led strip
  // Uncomment one of the following lines for your leds arrangement.
  // FastLED.addLeds<WS2812, DATA_PIN, RGB>(leds, NUM_LEDS);
  FastLED.addLeds<WS2812B, DATA_PIN, GRB>(leds, NUM_LEDS);
  // FastLED.addLeds<NEOPIXEL, DATA_PIN, GRB>(leds, NUM_LEDS);

  // blank out the LEDs
  setupLEDs();
}

int readByte(){
  while(Serial.available()==0){
  }
  return Serial.read();
}

// show colored LEDs for 500ms then blanks out ready to go
void setupLEDs(){
  memset(leds,150, sizeof(leds));
  FastLED.show();
  delay(500);
  memset(leds,0, sizeof(leds));
  FastLED.show();
}

void loop(){
  if(readByte() == 0xFF){
    if(readByte() == 0x00){
      if(readByte() == 0x00){
        int channels = readByte();
        for(int channel=0; channel<channels; channel++){
          leds[channel].r = readByte();
          leds[channel].g = readByte();
          leds[channel].b = readByte();
        }
        FastLED.show();
      }
    }
  }
}
